package org.vamdc.test;
import java.util.ArrayList;
import java.util.Collection;

import org.astrogrid.registry.RegistryException;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import eu.vamdc.registry.Registry;

public class TestQuery {

	public static void main(String[] args){
		for (String ivoaid:getIVOAIDs()){
			System.out.println("IVOA identifier: "+ivoaid);
			System.out.println("TAP url: "+getTapURL(ivoaid));
			for (String restrict:getRestrictables(ivoaid)){
				System.out.println("     Restrictable "+restrict);
			}
		};
		
	}
	
	private static Collection<String> getRestrictables(String ivoaID) {
		try {
			ArrayList<String> restricts = new ArrayList<String>();
			Registry reggie = new Registry( );
		    String query = 
		        "declare namespace ri='http://www.ivoa.net/xml/RegistryInterface/v1.0'; " + 
		        "for $x in //ri:Resource " + 
		        "where identifier = '"+ivoaID+"'" +
		        "and $x/@status='active' " +
		        "return $x/capability[@standardID='ivo://vamdc/std/VAMDC-TAP']/restrictable";
		    Document results = reggie.executeXquery(query);
		    NodeList nl = results.getDocumentElement().getElementsByTagName("restrictable");
		   
		    for (int i = 0; i < nl.getLength(); i++) {
		    	//System.out.print(i);
		    	//System.out.println(nl.item(i).getFirstChild().getNodeValue());
		    	restricts.add(nl.item(i).getFirstChild().getNodeValue());
		    }
		    return restricts;

		} catch (RegistryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	private static Collection<String> getIVOAIDs() {
		try {
			ArrayList<String> ids = new ArrayList<String>();
			Registry reggie = new Registry( );
		    String query = 
		        "declare namespace ri='http://www.ivoa.net/xml/RegistryInterface/v1.0'; " + 
		        "for $x in //ri:Resource " + 
		        "where $x/capability[@standardID='ivo://vamdc/std/VAMDC-TAP']" +
		        "and $x/@status='active' " +
		        "return $x/identifier";
		    Document results = reggie.executeXquery(query);
		    NodeList nl = results.getDocumentElement().getElementsByTagName("identifier");
		   
		    for (int i = 0; i < nl.getLength(); i++) {
		    	//System.out.print(i);
		    	//System.out.println(nl.item(i).getFirstChild().getNodeValue());
		    	ids.add(nl.item(i).getFirstChild().getNodeValue());
		    }
		    return ids;
		} catch (RegistryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	private static String getTapURL(String ivoaid) {
		try {
			Registry reggie = new Registry();
		    String query = 
		        "declare namespace ri='http://www.ivoa.net/xml/RegistryInterface/v1.0'; " + 
		        "for $x in //ri:Resource " + 
		        "where identifier = '"+ivoaid+"'" +
		        "and $x/@status='active' " +
		        "return $x/capability[@standardID='ivo://vamdc/std/VAMDC-TAP']/interface/accessURL";
		    Document results = reggie.executeXquery(query);
		    NodeList nl = results.getDocumentElement().getElementsByTagName("accessURL");
		   
		    //for (int i = 0; i < nl.getLength(); i++) {
		    	//System.out.print(i);
		    	//System.out.println(nl.item(i).getFirstChild().getNodeValue());
		    if (nl.getLength()>0)	return nl.item(0).getFirstChild().getNodeValue();
		    //}

		} catch (RegistryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	private static void getTapURLs() {
		try {
			Registry reggie = new Registry();
		    String query = 
		        "declare namespace ri='http://www.ivoa.net/xml/RegistryInterface/v1.0'; " + 
		        "for $x in //ri:Resource " + 
		        "where $x/capability[@standardID='ivo://vamdc/std/VAMDC-TAP' " +
		        //"and restrictable='AtomSymbol'] " +
		        "and restrictable='MolecularSpeciesStoichiometrcFormula'] " +
		        "and $x/@status='active' " +
		        "return $x/capability[@standardID='ivo://vamdc/std/VAMDC-TAP']/interface/accessURL";
		    Document results = reggie.executeXquery(query);
		    NodeList nl = results.getDocumentElement().getElementsByTagName("accessURL");
		   
		    for (int i = 0; i < nl.getLength(); i++) {
		    	System.out.print(i);
		    	System.out.println(nl.item(i).getFirstChild().getNodeValue());
		    }

		} catch (RegistryException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}

	